diff --git a/debug/Makefile b/debug/Makefile
index cd4975c..10f9dea 100644
--- a/debug/Makefile
+++ b/debug/Makefile
@@ -139,12 +139,19 @@ LDFLAGS-tst-backtrace4 = -rdynamic
 LDFLAGS-tst-backtrace5 = -rdynamic
 LDFLAGS-tst-backtrace6 = -rdynamic
 
+CFLAGS-tst-ssp-1.c = -Wno-format -Wno-deprecated-declarations -Wno-error \
+		     -O0 -fstack-protector
+
 tests = backtrace-tst tst-longjmp_chk tst-chk1 tst-chk2 tst-chk3 \
 	tst-lfschk1 tst-lfschk2 tst-lfschk3 test-strcpy_chk test-stpcpy_chk \
 	tst-chk4 tst-chk5 tst-chk6 tst-lfschk4 tst-lfschk5 tst-lfschk6 \
 	tst-longjmp_chk2 tst-backtrace2 tst-backtrace3 tst-backtrace4 \
 	tst-backtrace5 tst-backtrace6
 
+ifeq ($(have-ssp),yes)
+tests += tst-ssp-1
+endif
+
 ifeq (,$(CXX))
 tests-unsupported = tst-chk4 tst-chk5 tst-chk6 \
 		    tst-lfschk4 tst-lfschk5 tst-lfschk6
diff --git a/debug/fortify_fail.c b/debug/fortify_fail.c
index a31977a..13063bf 100644
--- a/debug/fortify_fail.c
+++ b/debug/fortify_fail.c
@@ -23,11 +23,20 @@ extern char **__libc_argv attribute_hidden;
 
 void
 __attribute__ ((noreturn)) internal_function
-__fortify_fail (const char *msg)
+__fortify_fail_abort (int no_backtrace, const char *msg)
 {
   /* The loop is added only to keep gcc happy.  */
   while (1)
-    __libc_message (2, "*** %s ***: %s terminated\n",
+    __libc_message (no_backtrace ? 3 : 2, "*** %s ***: %s terminated\n",
 		    msg, __libc_argv[0] ?: "<unknown>");
 }
+
+void
+__attribute__ ((noreturn)) internal_function
+__fortify_fail (const char *msg)
+{
+  __fortify_fail_abort (0, msg);
+}
+
 libc_hidden_def (__fortify_fail)
+libc_hidden_def (__fortify_fail_abort)
diff --git a/debug/stack_chk_fail.c b/debug/stack_chk_fail.c
index 120d269..2f39e43 100644
--- a/debug/stack_chk_fail.c
+++ b/debug/stack_chk_fail.c
@@ -25,7 +25,7 @@ void
 __attribute__ ((noreturn))
 __stack_chk_fail (void)
 {
-  __fortify_fail ("stack smashing detected");
+  __fortify_fail_abort (1, "stack smashing detected");
 }
 
 #ifdef SHARED
diff --git a/debug/tst-ssp-1.c b/debug/tst-ssp-1.c
new file mode 100644
index 0000000..14d8e26
--- /dev/null
+++ b/debug/tst-ssp-1.c
@@ -0,0 +1,40 @@
+/* Copyright (C) 2017 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+/* Based on gcc.dg/ssp-1.c from GCC testsuite.  */
+
+#include <unistd.h>
+#include <signal.h>
+#include <abort-instr.h>
+
+static int do_test (void);
+#define TEST_FUNCTION do_test ()
+#define EXPECTED_SIGNAL SIGABRT
+#include "../test-skeleton.c"
+
+static int
+do_test (void)
+{
+  int i;
+  char foo[30];
+
+  // smash stack
+  for (i = 0; i <= 400; i++)
+    foo[i] = 42;
+
+  return 1; /* fail */
+}
diff --git a/include/stdio.h b/include/stdio.h
index f68f633..31dc7a6 100644
--- a/include/stdio.h
+++ b/include/stdio.h
@@ -92,7 +92,10 @@ extern void __libc_fatal (const char *__message)
 extern void __libc_message (int do_abort, const char *__fnt, ...);
 extern void __fortify_fail (const char *msg)
      __attribute__ ((__noreturn__)) internal_function;
+extern void __fortify_fail_abort (int, const char *msg)
+     __attribute__ ((__noreturn__)) internal_function;
 libc_hidden_proto (__fortify_fail)
+libc_hidden_proto (__fortify_fail_abort)
 
 /* Acquire ownership of STREAM.  */
 extern void __flockfile (FILE *__stream);
diff --git a/sysdeps/posix/libc_fatal.c b/sysdeps/posix/libc_fatal.c
index b261963..a0cd8b2 100644
--- a/sysdeps/posix/libc_fatal.c
+++ b/sysdeps/posix/libc_fatal.c
@@ -169,7 +169,8 @@ __libc_message (int do_abort, const char *fmt, ...)
 
   if (do_abort)
     {
-      BEFORE_ABORT (do_abort, written, fd);
+      if (do_abort < 3)
+	BEFORE_ABORT (do_abort, written, fd);
 
       /* Kill the application.  */
       abort ();